 
#include <WINDOWS.H>
#include <shellapi.h>
#include <shlobj.h>


#define DllExport __declspec( dllexport )
// Exported Functions for the various directories
DllExport int FindStartUp(HWND hOwner, LPTSTR lpbuffer);
DllExport int FindCommonStartUp(HWND hOwner, LPTSTR lpbuffer);
DllExport int FindCommonPrograms(HWND hOwner, LPTSTR lpbuffer);
DllExport int FindDesktopFolder(HWND hOwner, LPTSTR lpbuffer);
DllExport int FindCommonDesktop(HWND hOwner, LPTSTR lpbuffer);
DllExport int FindProgramFolder(HWND hOwner, LPTSTR lpbuffer);
DllExport int FindStartMenu(HWND hOwner, LPTSTR lpbuffer);
// Exported Functions to retrieve link file information
DllExport int GetCmndLineInfo(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath);
DllExport int GetLinkArgs(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszArguments);
DllExport int GetLinkDescription(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath);
DllExport short GetLinkHotKey(HWND hWnd, LPCTSTR lpszLinkName);
DllExport int GetLinkIconFile(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath, LPDWORD lpIconIndex);
DllExport int GetLinkWorkDir(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath);
DllExport int GetWindowState(HWND hWnd, LPCTSTR lpszLinkName);
// Exported Functions to set link file information.
DllExport int SetLinkWorkDir(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath);
DllExport int SetWindowState(HWND hWnd, LPCTSTR lpszLinkName, int iWinState);
DllExport int SetLinkIconFile(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath, int IconIndex);
DllExport int SetLinkHotKey(HWND hWnd, LPCTSTR lpszLinkName, short iHotKey);
DllExport int SetLinkArgs(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszArguments);
DllExport int SetCmndLineInfo(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath);
DllExport int SetLinkDescription(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath);
DllExport int CreateShellLink(LPSTR lpzLinkFileName, LPSTR lpzExeFileName);



BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
	}
	return TRUE;
}
DllExport int FindDesktopFolder(HWND hOwner, LPTSTR lpbuffer)
{
  LPITEMIDLIST ppidl;
  int iStrLen;
  SHGetSpecialFolderLocation(hOwner, CSIDL_DESKTOPDIRECTORY, &ppidl);
  SHGetPathFromIDList(ppidl, lpbuffer);
  iStrLen = lstrlen(lpbuffer);
  return iStrLen;
}

DllExport int FindCommonDesktop(HWND hOwner, LPTSTR lpbuffer)
{
  LPITEMIDLIST ppidl;
  int iStrLen;
  SHGetSpecialFolderLocation(hOwner, CSIDL_COMMON_DESKTOPDIRECTORY, &ppidl);
  SHGetPathFromIDList(ppidl, lpbuffer);
  iStrLen = lstrlen(lpbuffer);
  return iStrLen;
}
DllExport int FindStartUp(HWND hOwner, LPTSTR lpbuffer)
{
  LPITEMIDLIST ppidl;
  int iStrLen;
  SHGetSpecialFolderLocation(hOwner, CSIDL_STARTUP, &ppidl);
  SHGetPathFromIDList(ppidl, lpbuffer);
  iStrLen = lstrlen(lpbuffer);
  return iStrLen;
}
DllExport int FindCommonStartUp(HWND hOwner, LPTSTR lpbuffer)
{
  LPITEMIDLIST ppidl;
  int iStrLen;
  SHGetSpecialFolderLocation(hOwner, CSIDL_COMMON_STARTUP, &ppidl);
  SHGetPathFromIDList(ppidl, lpbuffer);
  iStrLen = lstrlen(lpbuffer);
  return iStrLen;
}
DllExport int FindCommonPrograms(HWND hOwner, LPTSTR lpbuffer)
{
  LPITEMIDLIST ppidl;
  int iStrLen;
  SHGetSpecialFolderLocation(hOwner, CSIDL_COMMON_DESKTOPDIRECTORY, &ppidl);
  SHGetPathFromIDList(ppidl, lpbuffer);
  iStrLen = lstrlen(lpbuffer);
  return iStrLen;
}
DllExport int FindProgramFolder(HWND hOwner, LPTSTR lpbuffer)
{
  LPITEMIDLIST ppidl;
  int iStrLen;
  SHGetSpecialFolderLocation(hOwner, CSIDL_PROGRAMS, &ppidl);
  SHGetPathFromIDList(ppidl, lpbuffer);
  iStrLen = lstrlen(lpbuffer);
  return iStrLen;
}

DllExport int FindStartMenu(HWND hOwner, LPTSTR lpbuffer)
{
  LPITEMIDLIST ppidl;
  int iStrLen;
  SHGetSpecialFolderLocation(hOwner, CSIDL_STARTMENU, &ppidl);
  SHGetPathFromIDList(ppidl, lpbuffer);
  iStrLen = lstrlen(lpbuffer);
  return iStrLen;
}

DllExport int GetCmndLineInfo(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath)
{
  HRESULT hres;
  int iStrlen = -5;
  IShellLink *pShLink;
  WIN32_FIND_DATA wfd;
  // Initialize the return parameter to a null string.
  *lpszPath = '\0';
  // Initialize the object interface
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  { // Create the instance of the link
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      // The IShellLink Interface supports the IPersistFile
      // interface. Get an interface pointer to it.
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        // Convert the given link name string to a wide character string.
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        // Load the file.
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        { // Resolve the link by calling the Resolve() interface function.
          // This enables us to find the file the link points to even if
          // it has been moved or renamed.
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
                                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          {  // Get the path of the file the link points to.
            ++iStrlen;
            hres = pShLink->lpVtbl->GetPath( pShLink, lpszPath,
                                             MAX_PATH,
                                             &wfd,
                                             SLGP_SHORTPATH );
            if (SUCCEEDED(hres))
              iStrlen = lstrlen(lpszPath);
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport int GetLinkArgs(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszArguments)
{
  HRESULT hres;
  int iStrlen = -5;
  IShellLink *pShLink;
  // Initialize the return parameter to a null string.
  *lpszArguments = '\0';
  // Initialize the object interface
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  { // Create the instance of the link
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      // The IShellLink Interface supports the IPersistFile
      // interface. Get an interface pointer to it.
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        // Convert the given link name string to a wide character string.
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        // Load the file.
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink, hWnd,
                                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          { // Get the description of the file the link points to.
            ++iStrlen;
            hres = pShLink->lpVtbl->GetArguments(pShLink,
                                                 lpszArguments,
                                                 MAX_PATH );				  
            if (SUCCEEDED(hres))
			  iStrlen = lstrlen(lpszArguments);
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport int GetLinkIconFile(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath, LPDWORD lpIconIndex)
{
  HRESULT hres;
  int iStrlen = -5;
  IShellLink *pShLink;
  // Initialize the return parameter to a null string.
  *lpszPath = '\0';
  // Initialize the object interface
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  { // Create the instance of the link
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      // The IShellLink Interface supports the IPersistFile
      // interface. Get an interface pointer to it.
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        // Convert the given link name string to a wide character string.
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        // Load the file.
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
				                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          {
            // Get the icon file the link points to.
            ++iStrlen;
            hres = pShLink->lpVtbl->GetIconLocation(pShLink,
                                                    lpszPath,
                                                    MAX_PATH,
			                                        lpIconIndex);				  
            if (SUCCEEDED(hres))
              iStrlen = lstrlen(lpszPath);
            }
          }
        }
        ppf->lpVtbl->Release(ppf);
      }
      pShLink->lpVtbl->Release(pShLink);
    }
	CoUninitialize();
	return iStrlen;
}

DllExport int GetWindowState(HWND hWnd, LPCTSTR lpszLinkName)
{
  HRESULT hres;
  // Initialize the return parameter to zero.
  int iWinState = -5;
  IShellLink *pShLink;
  // Initialize the object interface
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  {	// Create the instance of the link
    ++iWinState;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iWinState;
      // The IShellLink Interface supports the IPersistFile
      // interface. Get an interface pointer to it.
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iWinState;
        // Convert the given link name string to a wide character string.
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        // Load the file.
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iWinState;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
				                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
            // Get the SW_ value.
			hres = pShLink->lpVtbl->GetShowCmd(pShLink, &iWinState);
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iWinState;
}

DllExport int GetLinkWorkDir(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath)
{
  HRESULT hres;
  int iStrlen = -5;
  IShellLink *pShLink;
  // Initialize the return parameter to a null string.
  *lpszPath = '\0';
  // Initialize the object interface
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  { // Create the instance of the link
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
				                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          { // Get the working directory of the file the link points to.
            ++iStrlen;
            hres = pShLink->lpVtbl->GetWorkingDirectory(pShLink,
                                                         lpszPath,
                                                         MAX_PATH);
            if (SUCCEEDED(hres))
              iStrlen = lstrlen(lpszPath);
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport short GetLinkHotKey(HWND hWnd, LPCTSTR lpszLinkName)
{
  HRESULT hres;
  short iHotKey = -5;
  IShellLink *pShLink;
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  { // Create the instance of the link
    ++iHotKey;
	hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iHotKey;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iHotKey;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iHotKey;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
				                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
            // Get the hotkey value.
		    hres = pShLink->lpVtbl->GetHotkey(pShLink, &iHotKey);
		}
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iHotKey;
}

DllExport int GetLinkDescription(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath)
{
  HRESULT hres;
  int iStrlen = -5;
  IShellLink *pShLink;
  *lpszPath = '\0';
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  { // Create the instance of the link
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {  // Get the description of the file the link points to.
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
				                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          {
            ++iStrlen;
            hres = pShLink->lpVtbl->GetDescription(pShLink,
                                                   lpszPath,
                                                   MAX_PATH);
														 
            if (SUCCEEDED(hres))
              iStrlen = lstrlen(lpszPath);
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport int SetLinkWorkDir(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath)
{
  HRESULT hres;
  int iStrlen = -6;
  IShellLink *pShLink;
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  { 
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
				                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          { // Set the description of the file the link points to.
            ++iStrlen;
            hres = pShLink->lpVtbl->SetWorkingDirectory(pShLink, lpszPath);
            if (SUCCEEDED(hres))
            {
              ++iStrlen;
              hres = ppf->lpVtbl->Save(ppf, wsz, TRUE);
              if (SUCCEEDED(hres))
                ++iStrlen;
            }
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport int SetWindowState(HWND hWnd, LPCTSTR lpszLinkName, int iWinState)
{
  HRESULT hres;
  IShellLink *pShLink;
  int iStrlen = -6;
  // Initialize the object interface
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  {
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
				                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          {
            ++iStrlen;
            // Set the SW_ value.
            hres = pShLink->lpVtbl->SetShowCmd(pShLink, iWinState);
            if (SUCCEEDED(hres))
            {
              ++iStrlen;
              hres = ppf->lpVtbl->Save(ppf, wsz, TRUE);
              if (SUCCEEDED(hres))
                ++iStrlen;
            }
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport int SetLinkIconFile(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath, int IconIndex)

{
  HRESULT hres;
  int iStrlen = -6;
  IShellLink *pShLink;
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  {
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
				                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          {
            // Set the icon file the link points to.
            ++iStrlen;
            hres = pShLink->lpVtbl->SetIconLocation(pShLink,
                                                    lpszPath,
			                                        IconIndex);				  
            if (SUCCEEDED(hres))
            {
              ++iStrlen;
              hres = ppf->lpVtbl->Save(ppf, wsz, TRUE);
              if (SUCCEEDED(hres))
                ++iStrlen;
            }
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport int SetLinkHotKey(HWND hWnd, LPCTSTR lpszLinkName, short iHotKey)
{
  HRESULT hres;
  int iStrlen = -6;
  IShellLink *pShLink;
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  {	
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
		                                  SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          {
            ++iStrlen;
            // Set the Hot Key value.
            hres = pShLink->lpVtbl->SetHotkey(pShLink, iHotKey);
            if (SUCCEEDED(hres))
            {
              ++iStrlen;
              hres = ppf->lpVtbl->Save(ppf, wsz, TRUE);
              if (SUCCEEDED(hres))
                ++iStrlen;
            }
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport int SetLinkArgs(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszArguments)
{
  HRESULT hres;
  int iStrlen = -6;
  IShellLink *pShLink;
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  {
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
				                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          {
            ++iStrlen;
            // Set the arguments
            hres = pShLink->lpVtbl->SetArguments(pShLink, lpszArguments);
            if (SUCCEEDED(hres))
            {
              ++iStrlen;
              hres = ppf->lpVtbl->Save(ppf, wsz, TRUE);
              if (SUCCEEDED(hres))
                ++iStrlen;
            }
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport int SetCmndLineInfo(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath)
{
  HRESULT hres;
  int iStrlen = -6;
  IShellLink *pShLink;
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  {
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
          hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
                                          SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          {
            ++iStrlen;
            // Set the path of the file the link points to.
            hres = pShLink->lpVtbl->SetPath( pShLink, lpszPath);
            if (SUCCEEDED(hres))
            {
              ++iStrlen;
              hres = ppf->lpVtbl->Save(ppf, wsz, TRUE);
              if (SUCCEEDED(hres))
                ++iStrlen;
            }
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}


DllExport int SetLinkDescription(HWND hWnd, LPCTSTR lpszLinkName, LPSTR lpszPath)
{
  HRESULT hres;
  int iStrlen = -6;
  IShellLink *pShLink;
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  {
    ++iStrlen;
    hres = CoCreateInstance( &CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
                                            &IID_IPersistFile,
                                            (LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpszLinkName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Load(ppf, wsz, STGM_READ );
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
        hres = pShLink->lpVtbl->Resolve(pShLink,  hWnd,
                                        SLR_ANY_MATCH | SLR_NO_UI);
          if (SUCCEEDED(hres))
          {
            ++iStrlen;
            // Set the description
            hres = pShLink->lpVtbl->SetDescription(pShLink, lpszPath);
            if (SUCCEEDED(hres))
            {
              ++iStrlen;
              hres = ppf->lpVtbl->Save(ppf, wsz, TRUE);
              if (SUCCEEDED(hres))
                ++iStrlen;
            }
          }
        }
      }
      ppf->lpVtbl->Release(ppf);
    }
    pShLink->lpVtbl->Release(pShLink);
  }
  CoUninitialize();
  return iStrlen;
}

DllExport int CreateShellLink(LPSTR lpzLinkFileName, LPSTR lpzExeFileName)
{
  HRESULT hres;
  int iStrlen = -6;
  IShellLink *pShLink;
  hres = CoInitialize(NULL);
  if (SUCCEEDED(hres))
  {
    ++iStrlen;
    hres = CoCreateInstance(&CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							&IID_IShellLink,
							(LPVOID *)&pShLink );
    if (SUCCEEDED(hres))
    {
      IPersistFile *ppf;
      ++iStrlen;
      hres = pShLink->lpVtbl->QueryInterface(pShLink,
											&IID_IPersistFile,
											(LPVOID *)&ppf );
      if (SUCCEEDED(hres))
      {
        WORD wsz[MAX_PATH];
        ++iStrlen;
        MultiByteToWideChar( CP_ACP, 0, lpzLinkFileName, -1, wsz, MAX_PATH );
        hres = ppf->lpVtbl->Save(ppf, wsz, TRUE);
        if (SUCCEEDED(hres))
        {
          ++iStrlen;
          // Set the path
          hres = pShLink->lpVtbl->SetPath( pShLink, lpzExeFileName);
          if (SUCCEEDED(hres))
          {
            // Save it
            hres = ppf->lpVtbl->Save(ppf, wsz, TRUE);
            if (SUCCEEDED(hres))
              iStrlen = 0;
          }
        }
		ppf->lpVtbl->Release(ppf);
      }
      pShLink->lpVtbl->Release(pShLink);
    }
  }
  CoUninitialize();
  return iStrlen;
}
