*==============================================================================
* Program:			CancelNetConnection
* Purpose:			Cancels the network connection for a mapped device
* Author:			Doug Hennig
* Copyright:		(c) 2001 Stonefield Systems Group Inc.
* Last revision:	01/21/2001
* Parameters:		tcDevice - the device name
* Returns:			.T. if it was successful
* Environment in:	the specified device must exist and be mapped to a network
*						resource
* Environment out:	if successful, the device is no longer mapped to the
*						network resource
*==============================================================================

lparameters tcDevice
local lcName, ;
	llReturn

* If the path wasn't specified, use the current drive.

if vartype(tcDevice) <> 'C' or empty(tcDevice)
	lcName = sys(5)
else
	lcName = tcDevice
endif vartype(tcDevice) <> 'C' ...

* Declare and call the API function and return the result.

declare integer WNetCancelConnection in Win32API ;
	string lpLocalName, integer lpnForce
llReturn = WNetCancelConnection(lcName, 0) = 0
return llReturn
