*==============================================================================
* Program:			DriveExists
* Purpose:			Determines if the specified drive exists
* Author:			Doug Hennig
* Copyright:		(c) 2001 Stonefield Systems Group Inc.
* Last revision:	01/21/2001
* Parameters:		tcDrive - the drive letter to check
* Returns:			.T. if the specified drive exists
* Environment in:	none
* Environment out:	none
*==============================================================================

lparameters tcDrive
local lnDrives, ;
	lnDrive
assert vartype(tcDrive) = 'C' and isalpha(tcDrive) ;
	message 'Invalid drive specified'
declare integer GetLogicalDrives in Win32API
lnDrives = GetLogicalDrives()
lnDrive  = asc(upper(left(tcDrive, 1))) - asc('A')
return bittest(lnDrives, lnDrive)
