*==============================================================================
* Program:			GetUserName
* Purpose:			Returns the current user's login name
* Author:			Doug Hennig
* Copyright:		(c) 2001 Stonefield Systems Group Inc.
* Last revision:	01/21/2001
* Parameters:		none
* Returns:			the current user's login name
* Environment in:	none
* Environment out:	none
*==============================================================================

local lcName, ;
	lnSize, ;
	lcUser, ;
	lnStatus

* Initialize the variables we need and declare the Windows function.

lcName = chr(0)
lnSize = 64
lcUser = replicate(lcName, lnSize)
declare integer WNetGetUser in Win32API ;
	string @cName, string @cUser, integer @nBufferSize

* Call the function and return the result.

lnStatus = WNetGetUser(@lcName, @lcUser, @lnSize)
lcUser   = iif(lnStatus = 0, upper(left(lcUser, at(chr(0), lcUser) - 1)), '')
return lcUser
