*==============================================================================
* Program:			IsDiskIn
* Purpose:			Returns .T. if a disk is in the specified drive
* Author:			Doug Hennig, from code written by Ted Roche
* Copyright:		(c) 1999 Stonefield Systems Group Inc.
* Last revision:	09/07/1999
* Parameters:		tcDrive - the drive to check
* Returns:			.T. if a disk is in the specified drive
* Environment in:	none
* Environment out:	none
*==============================================================================

lparameters tcDrive
local lcDrive, ;
	lnWinErrMode, ;
	llCanRead
declare integer SetErrorMode in Win32API ;
	integer nErrorMode
lcDrive      = iif(substr(tcDrive, 2, 1) = ':', left(tcDrive, 2), tcDrive)
lnWinErrMode = SetErrorMode(1)
llCanRead    = diskspace(lcDrive) <> -1
SetErrorMode(lnWinErrMode)
return llCanRead
